#include <stdio.h>
#include <signal.h>
#include <sys/time.h>

#include "daemon.h"

FILE * in, * out;

void sig_pipe(int);
void openfile(void);
void closefile(void);

void sig_pipe(int i)
{
	signal(SIGPIPE, SIG_IGN);
	closefile();
	openfile();
	signal(SIGPIPE, sig_pipe);
}

void openfile(void)
{
	in = fopen("/dev/psaux", "rb");
	out = fopen("/dev/mouse", "wb");
	if ((in == NULL) || (out == NULL)) exit(1);
}

void closefile(void)
{
	fclose(in);
	fclose(out);
}

void main(void)
{
	char ch[3];
	char zeros[3];
	struct timeval tv;
	long int diff, lasttime, curtime;
	int drag = 0;  /* 0 = off, 1 = on */

	signal(SIGPIPE, SIG_IGN);

	daemon_start(1);

	diff = lasttime = curtime = 0;
	zeros[0] = zeros[1] = zeros[2] = 0;

	signal(SIGPIPE, sig_pipe);

	openfile();
	fflush(in);

	while (1) {
		lasttime = curtime;
		fread(&ch, 3, 1, in);
		gettimeofday(&tv, NULL);
		curtime = tv.tv_usec + (tv.tv_sec * 1000000);
		
		if ((ch[0] == 0) && (ch[1] == 0) && (ch[2] == 0)) {
			ch[0] = 9;
			if ((drag) && ((curtime - lasttime) < 400000)) {
				/* Release key */
				drag = 0;
				fwrite(&zeros, 3, 1, out);
			} else
				drag = 1;
		} else if (drag) {
			if ((curtime - lasttime) < 400000) {
				if (!((ch[0] == 8) && (ch[1] == 0) &&
				      (ch[2] == 0))) {
					ch[0] |= 9;
				}
				/* Silently discard release garbage */
			} else {
				/* Release key! */
				drag = 0;
				fwrite(&zeros, 3, 1, out);
			}	
		}
		fwrite(&ch, 3, 1, out);
		fflush(out);
	}
}
